package com.bocloud.cop.booter.controller;

import com.bocloud.cop.intf.ServerServiceMgtService;
import com.bocloud.cop.model.params.ServerServiceManageParams;
import com.bocloud.cop.model.params.ServerServiceShellParams;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.RequestContext;
import com.megatron.common.utils.Common;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.PatchMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * BMP-主机服务管理Controller
 *
 * @author sxp
 * @since Dec 29, 2017
 */
@RestController
@RequestMapping("/v1/servers")
@Tag(name = "主机服务管理")
public class ServerServiceController {
    @Autowired
    private ServerServiceMgtService serverServiceMgtService;

    /**
     * 服务管理
     *
     * @param params
     * @param context
     * @return
     */
    @PatchMapping("/services")
    @Operation(tags = {"CMC", "CSC"}, summary = "服务管理")
    public GeneralResult<?> manage(@RequestBody ServerServiceManageParams params,
                                   @Value(Common.REQ_CONTEXT) RequestContext context) {

        return serverServiceMgtService.manage(params, context.getTarget());
    }

    /**
     * shell命令执行
     *
     * @param params
     * @param context
     * @return
     */
    @PatchMapping("/shells")
    @Operation(tags = {"CMC", "CSC"}, summary = "shell命令执行")
    public GeneralResult<?> shell(@RequestBody ServerServiceShellParams params,
                                  @Value(Common.REQ_CONTEXT) RequestContext context) {

        return serverServiceMgtService.shell(params, context.getTarget());
    }
}
