package com.bocloud.cop.booter.controller;

import com.bocloud.cop.entity.TaskInstanceIndex;
import com.bocloud.cop.intf.TaskInstanceIndexService;
import com.bocloud.cop.model.ResultTrend;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.GridBean;
import com.megatron.common.model.Pager;
import com.megatron.common.model.RequestContext;
import com.megatron.common.utils.Common;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author lyy
 * @date 2023年04月04日 10:26
 */
@RestController
@RequestMapping("/v1/tasks/instance/index")
@Tag(name = "平台任务指标管理")
public class TaskInstanceIndexController {
	@Autowired
	private TaskInstanceIndexService taskInstanceIndexService;

	@GetMapping
	@Operation(tags = { "CMC", "CSC" }, summary = "平台任务指标列表")
	public GeneralResult<GridBean<TaskInstanceIndex>> list(Pager pager) {
		return taskInstanceIndexService.list(pager);
	}

//	@GetMapping("/count")
//	@Operation(tags = { "CMC", "CSC" }, summary = "平台任务指标列表")
	public GeneralResult<Void> countList(@RequestParam(value = "startTime", required = false) String startTime,
			@RequestParam(value = "endTime", required = false) String endTime,
			@Value(Common.REQ_CONTEXT) RequestContext context) {
		return taskInstanceIndexService.countIndex(startTime, endTime, context.getTarget(), null);
	}

	@GetMapping("/application/count")
	@Operation(tags = { "CMC", "CSC" }, summary = "平台任务统计")
	public GeneralResult<ResultTrend> applicationCount(@Value(Common.REQ_CONTEXT) RequestContext context,
			@RequestParam(value = "period", required = false) String period,
			@RequestParam(value = "name", required = false) String name,
			@RequestParam(value = "startTime", required = false) String startTime,
			@RequestParam(value = "endTime", required = false) String endTime) {
		return taskInstanceIndexService.applicationCount(period, name, startTime, endTime);
	}
}
