package com.bocloud.cop.entity;

import java.util.Date;
import java.util.List;

import org.springframework.format.annotation.DateTimeFormat;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.IgnoreUpdate;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

/**
 * 认证类
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("identification")
public class Identification extends Generic {

    @PK(value = PKStrategy.AUTO)
    private Long id;
    /**
     * 用户名
     */
    @Column("username")
    private String username;
    /**
     * 密码
     */
    @Column("password")
    private String password;
    /**
     * 是否sudo
     */
    @Column("is_sudo")
    private Boolean isSudo;
    /**
     * 备注
     */
    @Column("remark")
    private String remark;
    /**
     * 创建时间
     */
    @Column("gmt_create")
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtCreate;

    /**
     * 修改时间
     */
    @Column("gmt_modify")
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtModify;
    /**
     * 创建人
     */
    @Column("creator_id")
    @IgnoreUpdate
    private Long creatorId;
    /**
     * 修改人
     */
    @Column("mender_id")
    private Long menderId;
    /**
     * 账号名称
     */
    @Column("account_name")
    private String accountName;

    @Column("is_deleted")
    private Boolean deleted;

    @IgnoreAll
    private String mender;

    @IgnoreAll
    private String creator;

    /**
     * 关联资源的数量
     */
    @IgnoreAll
    private Long relationCount;

    @IgnoreAll
    private List<Long> taskHostIds;

    @IgnoreAll
    private String oldPassword;

}
