package com.bocloud.cop.entity;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.Generic;
import com.megatron.entity.meta.PKStrategy;

import lombok.Data;

/**
 * 运维资源与认证账号的关系表
 *
 * @author hongqingyu
 * @version 1.0
 * @since 2022.06.09
 */
@Data
@Table("resource_identification_relation")
public class ResourceIdentificationRelation extends Generic {

    /**
     * id
     */
    @PK(value = PKStrategy.AUTO)
    private Long id;

    /**
     * 资源id
     */
    @Column("resource_id")
    private Long resourceId;

    /**
     * 认证账号id
     */
    @Column("identification_id")
    private Long identificationId;

    @Column("resource_type")
    private String resourceType;

    @IgnoreAll
    private String identificationName;

    public static enum ResourceType {
        /**
         * 主机
         */
        HOST,
        /**
         * 数据库
         */
        DB,
        /**
         * 网络
         */
        NETWORK
    }

    public ResourceIdentificationRelation(Long resourceId, Long identificationId, String resourceType) {
        super();
        this.resourceId = resourceId;
        this.identificationId = identificationId;
        this.resourceType = resourceType;
    }

    public ResourceIdentificationRelation() {
        super();
    }

}
