package com.bocloud.cop.entity;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

/**
 * 脚本类
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("script")
public class Script extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id; // ID
    @Column("content")
    private String content; // 脚本内容
    @Column("category")
    private String category; // 脚本类型
    @Column("group_id")
    private Long groupId; // 分组ID
    @Column("group_ids")
    private Object groupIds; // 分组IDs
    @IgnoreAll
    private String groupName; // 分组名称
    @Column("is_open")
    private Boolean open;
    @Column("version")
    private String version;
    @Column("filename")
    private String filename;
    @Column("version_id")
    private Long versionId;
    @IgnoreAll
    private String creator;
    @IgnoreAll
    private String mender;
    @IgnoreAll
    private String params;

    public Script(String name, String category, String content, Long creatorId, Long menderId, String status) {
        this.setName(name);
        this.setStatus(status);
        this.setCreatorId(creatorId);
        this.setMenderId(menderId);
        this.category = category;
        this.content = content;
    }

}
