package com.bocloud.cop.entity;

import java.util.List;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;

/**
 * 脚本分组类
 * 
 * @author weiwei
 * @version 1.0
 * @since 2016.08.16
 * 
 */
@Table("script_group")
public class ScriptGroup extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id; // ID
    @Column("parent_id")
    private Long parentId; // 父节点
    // @Column("tenant_id")
    // private Long tenantId; // 租户ID
    @IgnoreAll
    private String children;
    @IgnoreAll
    private List<ScriptGroup> childrenList; // 子节点
    @Column("code")
    private String code; // 编码

    /**
     * @return the id
     */
    public Long getId() {
        return id;
    }

    /**
     * @param id
     *            the id to set
     */
    public void setId(Long id) {
        this.id = id;
    }

    /**
     * @return the parentId
     */
    public Long getParentId() {
        return parentId;
    }

    /**
     * @param parentId
     *            the parentId to set
     */
    public void setParentId(Long parentId) {
        this.parentId = parentId;
    }

    /**
     * @return the children
     */
    public String getChildren() {
        return children;
    }

    /**
     * @param children
     *            the children to set
     */
    public void setChildren(String children) {
        this.children = children;
    }

    /**
     * @return the childrenList
     */
    public List<ScriptGroup> getChildrenList() {
        return childrenList;
    }

    /**
     * @param childrenList
     *            the childrenList to set
     */
    public void setChildrenList(List<ScriptGroup> childrenList) {
        this.childrenList = childrenList;
    }

    /**
     * @return the code
     */
    public String getCode() {
        return code;
    }

    /**
     * @param code
     *            the code to set
     */
    public void setCode(String code) {
        this.code = code;
    }

}
