package com.bocloud.cop.entity;


import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.megatron.common.utils.DateDeserializer;
import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;
import java.util.List;

/**
 * 任务实例平台告警
 *
 * @author majiali
 * @version 1.0
 * @since 2022.08.24
 */
@Data
@Table("task_platform_alert")
public class TaskPlatformAlert extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id;
    @Column("platform")
    private String platform;
    @Column("period")
    private Integer period;
    @Column("instance_num")
    private Integer instanceNum;
    @Column("target_host_num")
    private Integer targetHostNum;
    @Column("platform_config_id")
    private Long platformConfigId;
    @Column("start_time")
    private String startTime;
    @Column("end_time")
    private String endTime;
    @Column("deal_method")
    private String dealMethod;
    @Column("deal_id")
    private Long dealId; // 处理人ID
    @Column("deal_time")
    @JsonSerialize(
            using = DateSerializer.class
    )
    @JsonDeserialize(
            using = DateDeserializer.class
    )
    @DateTimeFormat(
            pattern = "yyyy-MM-dd HH:mm:ss"
    )
    private Date DealTime; // 处理时间

    @IgnoreAll
    private Integer currTargetHostNum;
    @IgnoreAll
    private Integer currInstanceNum;

    @IgnoreAll
    private String dealName;

    @IgnoreAll
    private List<TaskInstance> runningTasks;
    @IgnoreAll
    private List<TaskInstance> queueTasks;
    @IgnoreAll
    private List<TaskInstance> discardTasks;

}
