package com.bocloud.cop.entity;


import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.Data;

import java.util.List;

/**
 * 任务实例平台
 *
 * @author majiali
 * @version 1.0
 * @since 2022.08.24
 */
@Data
@Table("task_platform_config")
public class TaskPlatformConfig extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id;
    @Column("platform")
    private String platform;
    @Column("period")
    private Integer period;
    @Column("instance_num")
    private Integer instanceNum;
    @Column("target_host_num")
    private Integer targetHostNum;
    @Column("noticers")
    private String noticers;
    @Column("start_time")
    private String startTime;
    @Column("end_time")
    private String endTime;
    @Column("is_opened")
    private Boolean opened;

    @IgnoreAll
    private Integer currTargetHostNum;
    @IgnoreAll
    private Integer currInstanceNum;
    @IgnoreAll
    private List<TaskPlatformAlert> alertList;
    @IgnoreAll
    private String createrName;
    @IgnoreAll
    private String noticersName;
    @IgnoreAll
    private TaskPlatformAlert currAlert;
    @IgnoreAll
    private TaskPlatformAlert createdAlert;

}
