package com.bocloud.cop.entity;

import java.util.List;

import com.megatron.common.model.RequestContext;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

/**
 * 任务模板类
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("task_template")
public class TaskTemplate extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id; // ID
    @Column("graph")
    private Object graph;
    @Column("scene_id")
    private Long sceneId;
    @Column("internal")
    private Boolean internal;
    @Column("has_suspend")
    private Boolean hasSuspend;
    @Column("has_reuse")
    private Boolean hasReuse;
    @Column("is_maintain")
    private Boolean maintain;
    @Column("execute_type")
    private String executeType;
    @Column("tenant_id")
    private Long tenantId; // 租户ID
    @Column("catalog")
    private RequestContext.Catalog catalog;// 账号类别
    @IgnoreAll
    private int taskCount;
    @IgnoreAll
    private String sceneName;
    @IgnoreAll
    private String creator;
    @IgnoreAll
    private String mender;
    // 分配租户ID
    @IgnoreAll
    private List<Long> tenantIds;
    @IgnoreAll
    private String tenantName;

}
