package com.bocloud.cop.entity.backup;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * @author huliwei
 * @date 2022/10/19
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@Table("task_backup")
public class TaskBackup extends GenericEntity {
    @PK(value = PKStrategy.AUTO)
    private Long id;
    /**
     * 场景id
     */
    @Column("scene_id")
    private Long sceneId;
    /**
     * 场景名称
     */
    @Column("scene_name")
    private String sceneName;
    /**
     * 备份路径
     */
    @Column("path")
    private String path;
    /**
     * 任务类型
     */
    @Column("task_type")
    private String taskType;

    /**
     * 定时表达式
     */
    @Column("cron")
    private String cron;

    /**
     * 目标主机id
     */
    @Column("host_ids")
    private String hostIds;

    /**
     * 任务编码
     */
    @Column("code")
    private String code;

    @Column("target")
    private String target;

    /**
     * 场景路径
     */
    @IgnoreAll
    private List<TaskBackupScene> taskBackupScenes;

    @IgnoreAll
    private String creator;

    @IgnoreAll
    private String mender;

    @IgnoreAll
    private String hostIps;
}
