package com.bocloud.cop.entity.compare;


import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.Data;

/**
 * @Author liuyuanyuan
 * @Date 2022-10-292 16:04:48
 * @Description:
 */
@Data
@Table("task_document_comparison")
public class TaskDocumentComparison extends GenericEntity {

    /**
     * id
     */
    @PK(value = PKStrategy.AUTO)
    private Long id;

    @Column("code")
    private String code;

    /**
     * 对比类型
     */
    @Column("category")
    private String category;

    /**
     * 任务类型
     */
    @Column("task_type")
    private String taskType;

    /**
     * 选项
     */
    @Column("options")
    private String options;

    /**
     * 定时表达式
     */
    @Column("cron")
    private String cron;

    /**
     * 对比对象
     * 其中comparisonObject参数需要特别注意根据创建的任务种类不同参数不同具体如下：
     * 	①版本对比[{"versionId":"verion1的id","fileIds":"文件的ids"},{"versionId":"verion1的id","fileIds":"文件的ids"}]
     * 	②标准对比[{"source":"目标主机文件路径","fileId":"标准对比文件id"}]
     * 	③历史对比[{"source":"目标主机文件路径"}]
     * 	④跨机对比[{"source":"目标主机文件路径"}]
     */
    @Column("comparison_object")
    private String comparisonObject;

    /**
     * 文件版本
     */
    @Column("version_id")
    private Long versionId;

    /**
     * 目标主机id
     */
    @Column("host_ids")
    private String hostIds;

    @Column("target")
    private String target;

    @IgnoreAll
    private String hostIps;

    @IgnoreAll
    private String creator;

    @IgnoreAll
    private String mender;

    /**
     * 版本名称
     */
    @IgnoreAll
    private String versionName;

}