package com.bocloud.cop.entity.compare;


import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @Author liuyuanyuan
 * @Date 2022-10-292 17:36:49
 * @Description:
 */
@Data
@Table("task_instance_document_comparison")
public class TaskInstanceDocumentComparison extends GenericEntity {

    /**
     * id
     */
    @PK(value = PKStrategy.AUTO)
    private Long id;

    /**
     * 文件对比任务id
     */
    @Column("document_comparison_id")
    private Long documentComparisonId;


    /**
     * 任务编号
     */
    @Column("uuid")
    private String uuid;

    /**
     * 备份任务实例
     */
    @Column("task_instance_ids")
    private String taskInstanceIds;

    /**
     * 开始时间
     */
    @Column("gmt_start")
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtStart;

    /**
     * 结束时间
     */
    @Column("gmt_finish")
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtFinish;

    /**
     * 对比类型
     */
    @Column("category")
    private String category;


    @IgnoreAll
    private String creator;

    @IgnoreAll
    private String cron;

    @IgnoreAll
    private String hostIps;

    /**
     * 总耗时
     */
    @IgnoreAll
    private Double cost;

}