package com.bocloud.cop.entity.inspection;

import java.util.List;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

/**
 * 常规巡检
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("inspect")
public class Inspect extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id; // ID
    @Column
    private String category; // 巡检分类 主机、数据库、其他、……
    @Column
    private String type; // 合规、巡检

    @IgnoreAll
    private List<InspectGroup> groups;
    @IgnoreAll
    private String creator;
    @IgnoreAll
    private String mender;

}
