package com.bocloud.cop.entity.inspection;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("inspect_record_warning")
public class InspectRecordWarning extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id; // ID

    @Column
    private Long recordId;

    @Column
    private String groupName;

    @Column
    private String ip;

    @Column
    private Long itemId;// 巡检项ID

    @Column
    private String itemName;

    @Column
    private String content;

    @Column
    private Integer level;

    @Column
    private String targetRule;// JSON

    @Column
    private String inspectKey;// 多值匹配时的巡检值 单值匹配时为空

    @Column
    private String value;

    @Column
    private String valueName;

    @Column
    private String resourceName;

}
