package com.bocloud.cop.entity.inspection;

import java.util.Date;
import java.util.List;

import com.alibaba.fastjson.JSONObject;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;

import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 巡检报表详情表
 *
 * @author jiaohongtao
 * @since 2020-11-03 15:04:28
 */
@EqualsAndHashCode(callSuper = true)
@Data
@Table("inspect_report_detail")
public class InspectReportDetail extends GenericEntity {
    @PK
    private Long id;
    /**
     * 报表ID
     */
    @Column("report_id")
    private Long reportId;
    /**
     * 生成时间
     */
    @Column("generate_time")
    private Date generateTime;
    /**
     * 标题
     */
    @Column("title")
    private String title;
    /**
     * 基础信息
     */
    @Column("base_msg")
    private String baseMsg;
    /**
     * 列表头部 信息/规则
     */
    @Column("list_msg")
    private String listMsg;

    /**
     * 列表内容
     */
    @IgnoreAll
    private List<JSONObject> listObjects;

    @IgnoreAll
    private String reportName;

    public void setCreatorMender(Long userId) {
        this.setCreatorId(userId);
        this.setMenderId(userId);
    }
}
