package com.bocloud.cop.entity.inspection;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

/**
 * 告警等级
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("inspect_warn_level")
public class InspectWarnLevel extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id; // ID
    @Column
    private String warnLevel; // 告警等级
    @Column
    private String color; // 告警颜色
    @IgnoreAll
    private String creator;
    @IgnoreAll
    private String mender;
}
