package com.bocloud.cop.entity.module;

import java.util.List;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

/**
 * 编排节点分组类
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("task_node_module_group")
public class NodeModuleGroup extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id; // ID
    @Column("code")
    private String code; // 编码
    @Column("icon")
    private String icon;// 图标类型
    @Column("parent_id")
    private Long parentId; // 父节点
    @Column("internal")
    private Boolean internal = false;
    @IgnoreAll
    private List<NodeModuleGroup> children; // 子节点
    @IgnoreAll
    private List<NodeModule> modules;

}
