package com.bocloud.cop.entity.patch;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("patch")
public class Patch extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id;
    @Column("patch_no")
    private String patchNo;
    @Column("files")
    private Object files;
    @Column("script_category_id")
    private Long scriptCategoryId;
    @Column("script_id")
    private Long scriptId;
    @Column("script_content")
    private String scriptContent;
    @Column("script_type")
    private String scriptType;

    @IgnoreAll
    private String creator; // 创建者

    @IgnoreAll
    private int installCount; // 已安装数量

    @IgnoreAll
    private String path;

    @Data
    public static class File {

        private Long fileId;
        private String path;

    }

}
