package com.bocloud.cop.entity.patch;

import java.util.Date;

import org.springframework.format.annotation.DateTimeFormat;

import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.megatron.common.utils.DateDeserializer;
import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("patch_deploy")
public class PatchDeploy extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id;
    @Column("type")
    private String type;
    @Column("execute_template")
    private Long executeTemplate;
    @Column("sudo")
    private Boolean sudo;
    @Column("target")
    private Object target;
    @Column("choose_patch")
    private String choosePatch;
    @Column("patch_target")
    private Object patchTarget;
    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date timing;
    @Column("param")
    private Object param;
    @Column("is_timing")
    private Boolean isTiming;
    @Column("instance_id")
    private Long instanceId;
    @Column("choose_patch_path")
    private Object choosePatchPath;
    @Column("deploy_path")
    private String deployPath; // 执行路径
    @Column("batch_quantity")
    private Integer batchQuantity; // 每批安装数量
    /**
     * 补丁id
     */
    @Column("patch_id")
    private Long patchId;

    @IgnoreAll
    private String creator;
    @IgnoreAll
    private String templateName;
    @IgnoreAll
    private String patchName;
    @IgnoreAll
    private Integer installCount;

    @Data
    public static class Patch {
        private Long id;
        private Integer order;
    }

    @Data
    public static class Param {
        private String id;
        private String code;
        private String value;
        private String description;
        @JSONField(name = "path_name")
        private String pathName;
    }
}
