package com.bocloud.cop.entity.patch;

import java.util.Date;

import org.springframework.format.annotation.DateTimeFormat;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.megatron.common.utils.DateDeserializer;
import com.megatron.common.utils.DateSerializer;
import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("patch_deploy_history")
public class PatchDeployHistory extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id;
    @Column("type")
    private String type;
    @Column("patch_num")
    private Integer patchNum;
    @Column("serve_num")
    private Integer serveNum;
    @Column("fail_success_total")
    private String failSuccessTotal;
    @Column("execute_template")
    private String executeTemplate;
    @JsonSerialize(using = DateSerializer.class)
    @JsonDeserialize(using = DateDeserializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date completeTime;
    @Column("patch_id")
    private Long patchId;
    @Column("deploy_id")
    private Long deployId;
    @Column("task_instance_id")
    private Long taskInstanceId;

    @IgnoreAll
    private String creator;
}
