package com.bocloud.cop.entity.patch;

import com.megatron.entity.annotations.Column;
import com.megatron.entity.annotations.IgnoreAll;
import com.megatron.entity.annotations.PK;
import com.megatron.entity.annotations.Table;
import com.megatron.entity.bean.GenericEntity;
import com.megatron.entity.meta.PKStrategy;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;

@Data
@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode(callSuper = true)
@Table("patch_deploy_history_detail")
public class PatchDeployHistoryDetail extends GenericEntity {

    @PK(value = PKStrategy.AUTO)
    private Long id;
    @Column("host_ip")
    private String hostIp;
    @Column("patch_name")
    private String patchName;
    @Column("type")
    private String type;
    @Column("error_info")
    private String errorInfo;
    @Column("history_id")
    private Long historyId;
    @Column("node_id")
    private Long nodeId;
    @Column("node_name")
    private String nodeName;
    @Column("patch_id")
    private Long patchId;
    @Column("deploy_id")
    private Long deployId;
    @Column("host_id")
    private Long hostId;

    @IgnoreAll
    private String creator;

}
