package com.bocloud.cop.enums;

/**
 * 状态枚举类
 * 
 * @author dmw
 *
 */
public class Status {

    /**
     * 任务状态
     * 
     * @author dmw
     *
     */
    public static enum Task {
        /**
         * 激活
         */
        ACTIVE,
        /**
         * 挂起
         */
        SUSPEND,
        /**
         * 新创建
         */
        CREATED,
        /**
         * 已执行
         */
        EXECUTED
    }

    /**
     * 任务实例状态
     * 
     * @author dmw
     *
     */
    /**
     * @author weiwei
     *
     */
    /**
     * @author weiwei
     *
     */
    public static enum Inst {
        /**
         * 未处理
         */
        UNTREATED,
        /**
         * 新创建
         */
        CREATED,
        /**
         * 等待中
         */
        WAITTING,
        /**
         * 运行中
         */
        RUNNING,
        /**
         * 已暂停
         */
        SUSPENDED,
        /**
         * 成功
         */
        SUCCESS,
        /**
         * 失败
         */
        FAILED,
        /**
         * 异常
         */
        EXCEPTION,
        /**
         * 取消中
         */
        CANCELING,
        /**
         * 已取消
         */
        CANCELED,
        /**
         * 申请中
         */
        APPROVING,
        /**
         * 已结束
         */
        END;
    }

    /**
     * 任务节点状态
     * 
     * @author dmw
     *
     */
    public static enum Node {
        /**
         * 不可执行
         */
        NOREADY,
        /**
         * 可执行
         */
        READY,
        /**
         * 运行中
         */
        RUNNING,
        /**
         * 成功
         */
        SUCCESS,
        /**
         * 失败
         */
        FAILED,
        /**
         * 异常
         */
        EXCEPTION,
        /**
         * 已暂停
         */
        SUSPENDED,
        /**
         * 已跳过
         */
        SKIPPED,
        /**
         * 已取消
         */
        CANCELED;
    }

    public static enum TaskType{
        /**
         * 即时
         */
        IMMEDIATE,
        /**
         * 定时
         */
        TIMING
    }
}
