package com.bocloud.cop.enums;

import java.util.Arrays;
import java.util.Optional;

/**
 * @author admin
 */
public enum TaskNodeSort {
    MongoMaster("mongo_master",1),
    MongoArbiter("mongo_arbiter",2),
    MongoReplicas("mongo_replicas",3),
    MemcachedMasters("memcached_masters",1),
    MemcachedBackups("memcached_backups",2),
    MagentHosts("magent_hosts",3),
    MysqlMaster("mysql_master",1),
    MysqlSlave("mysql_slave",2),
    RedisMaster("redis_master",1),
    RedisSlave("redis_slave",2);


    private String name;
    private Integer value;

    TaskNodeSort(String name,Integer value) {
        this.name = name;
        this.value = value;
    }

    public String getName() {
        return this.name;
    }
    public Integer getValue() {
        return this.value;
    }

    public static TaskNodeSort getByName(String name){
        Optional<TaskNodeSort> any = Arrays.stream(TaskNodeSort.class.getEnumConstants())
                .filter(e -> e.getName().equals(name)).findAny();
        if (any.isPresent()){
            return any.get();
        }
        return null;
    }
}
