package com.bocloud.cop.enums;

/**
 * 主题类
 * 
 * @author dmw
 *
 */
public class Topic {

    public static enum Task {
        /**
         * 任务动作主题
         */
        Action("topic.task.action.#"),
        /**
         * 任务结果主题
         */
        Result("topic.task.result.#");

        private String topic;

        private Task(String topic) {
            this.topic = topic;
        }

        /**
         * @return the topic
         */
        public String getTopic() {
            return topic;
        }
    }

    /**
     * 任务节点主题
     * 
     * @author dmw
     *
     */
    public static enum Node {
        /**
         * 任务节点结果主题
         */
        Result("topic.node.result.#");

        private String topic;

        private Node(String topic) {
            this.topic = topic;
        }

        /**
         * @return the topic
         */
        public String getTopic() {
            return topic;
        }
    }
}
