package com.bocloud.cop.model;

import java.util.List;

import lombok.Data;

@Data
public class NodeGroup {

    private String id;
    private long zIndex;
    private Position position;
    private Size size;
    private String shape;
    private List<String> children;
    private String label;

    public NodeGroup() {
        super();
    }

    public NodeGroup(String id, long zIndex, int x, int y, int count, String label, List<String> children) {
        super();
        this.id = id;
        this.zIndex = zIndex;
        if (count == 3) {
            this.size = new Size(450, 185);
        } else {
            this.size = new Size(305, 185);
        }
        this.position = new Position(x, y);
        this.label = label;
        this.children = children;
    }

    public class Size {
        long width;
        long height;

        public long getWidth() {
            return width;
        }

        public void setWidth(long width) {
            this.width = width;
        }

        public long getHeight() {
            return height;
        }

        public void setHeight(long height) {
            this.height = height;
        }

        public Size(long width, long height) {
            super();
            this.width = width;
            this.height = height;
        }
    }

    public class Position {
        int x;
        int y;

        public int getX() {
            return x;
        }

        public void setX(int x) {
            this.x = x;
        }

        public int getY() {
            return y;
        }

        public void setY(int y) {
            this.y = y;
        }

        public Position(int x, int y) {
            super();
            this.x = x;
            this.y = y;
        }
    }

}
