package com.bocloud.cop.model;

import lombok.Data;

/**
 * @Description: redis 中 缓存的平台任务告警配置信息
 * @Title: TaskPlatformModel
 * @Author: majiali
 * @CreateTime: 2022/9/21 15:31
 */
@Data
public class TaskPlatformModel {
    private String name;
    //告警对应的平台
    private String platform;
    //告警配置设置的周期
    private Integer period;
    //告警配置设置的任务数
    private Integer instanceNum;
    //告警配置设置的主机数
    private Integer targetHostNum;
    //告警配置中设置的通知人
    private String noticers;
    //告警配置中的 执行时间 对应的开始时间
    private String startTime;
    //告警配置中的 执行时间 对应的结束时间
    private String endTime;
    //当前周期已经执行的主机数
    private Integer currTargetHostNum;
    //当前周期已经执行的任务数
    private Integer currInstanceNum;
    //平台告警配置id
    private Long platformConfigId;
    //已处理的平台告警id
    private Long platformAlertId;
    //限流操作类型 排队或者丢弃
    private String dealMethod;
    //当前周期（periodStartTime-periodEndTime）未处理的告警
    private Long currPlatformAlertId;
    //是否限流
    private boolean isLimit;
    //当前周期的开始时间
    private String periodStartTime;
    //当前周期的开始时间
    private String periodEndTime;
    //当前时间段（startTime-endTime）是否存在未处理的告警
    private boolean existCreateAlert;

}
