package com.bocloud.cop.model.backup;

import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.megatron.common.utils.DateSerializer;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @author huliwei
 * @date 2022/10/26
 */

@Data
@AllArgsConstructor
@NoArgsConstructor
public class TaskBackupInstanceNodeModel {
    /**
     * 实例id
     */
    private Long instanceId;

    /**
     * nodeId
     */
    private Long nodeId;

    /**
     * instanceHostId
     */
    private Long instanceHostId;

    /**
     * 场景名称
     */
    private String sceneName;

    /**
     * 备份路径
     */
    private String path;

    /**
     * 目标主机
     */
    private String host;

    /**
     *  备份时间
     */
    @JsonSerialize(using = DateSerializer.class)
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date gmtStart;

    /**
     *  下载路径
     */
    private String dest;

    /**
     * 是否成功
     */
    private boolean success;

}
