package com.bocloud.cop.model.inspection;

import java.util.List;
import java.util.TreeSet;

import lombok.Data;

/**
 * 存储巡检项中某个巡检值的信息和结果，以及对应的巡检规则
 */
@Data
public class ScriptLogResult {
    String key;
    List<ScriptLogResultEntity> entities;
    TreeSet<WarningRule> rules;

    /**
     * 单值匹配 /root++++70%@@@@mnt++++60% 或者 70%
     * 
     * @param key
     *            null
     * @param rules
     *            单值巡检规则
     * @param entities
     *            巡检结果
     */
    /**
     * 多值匹配 PERCENT====/root++++70%@@@@mnt++++60%||||IO_PERCENT====/root++++70%@@@@mnt++++60%
     *
     * @param key
     *            PERCENT
     * @param rules
     *            PERCENT对应的巡检规则
     * @param entities
     *            巡检结果
     * @see ScriptLogResultEntity
     */
    public ScriptLogResult(String key, TreeSet<WarningRule> rules, List<ScriptLogResultEntity> entities) {
        this.key = key;
        this.entities = entities;
        this.rules = rules;
    }
}
