package com.bocloud.cop.model.params;

import com.alibaba.fastjson.JSONObject;
import lombok.Data;

/**
 * @ClassName DeployGaiaArgs
 * @Description gaia部署参数
 * @Author majiali
 * @Date 2023/5/31 10:03
 * @Version 1.0
 **/
@Data
public class DeployGaiaArgs {

    /**
     * 版本   add和delete 不需要该字段
     */
    private String version;
    /**
     * add 新增、update 修改、delete 删除、更新  目前只支持add和delete
     */
    private String type;
    /**
     * config_share_path 是否配置共享文件路径 集群模式-共享存储（软件安装、文件备份分发必须有共享存储）
     */
    private Boolean config_share_path;
    /**
     * gfs_server 共享文件服务  config_share_path为true时必须有值【glusterfs集群只有二台服务器，只有gfs_server1_host和gfs_server2_host】
     * 参数为{"gfs_server1_host":"192.168.1.151","gfs_server2_host":"192.168.1.151"}
     */
    private JSONObject gfs_server;
    /**
     * gaia_package
     * add和delete 不需要该字段
     * gaia部署包路径，默认路径：/home/cmp/packages，gaia中配置
     *
     */
    private String gaia_package;

    /**
     * gaia_config gaia配置信息
     */
    private GaiaConfigParams gaia_config;
}
