package com.bocloud.cop.model.salt;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import com.megatron.common.utils.ListTool;
import com.bocloud.cop.entity.TaskWorker;

import lombok.Data;
import lombok.extern.slf4j.Slf4j;

/**
 * @author zoucg
 * @Company: 博云 www.bocloud.com
 * @ClassName: SaltCacheModel
 * @Description:
 * @DATE: 2022/2/24
 */
@Slf4j
@Data
public class SaltCacheModel {

    private List<SaltModel> saltModels;
    private int position;

    public void remove(Long id) {
        if (ListTool.isEmpty(saltModels)) {
            return;
        }
        Iterator<SaltModel> iterator = saltModels.iterator();
        while (iterator.hasNext()) {
            SaltModel model = iterator.next();
            if (id.compareTo(model.getId()) == 0) {
                iterator.remove();
            }
        }
    }

    public void add(TaskWorker worker) {
        try {
            String instance = worker.getInstance();
            String host = instance.substring(0, instance.indexOf(":"));
            Integer port = Integer.valueOf(instance.substring(instance.indexOf(":") + 1, instance.length()));
            SaltModel model = new SaltModel(worker.getId(), worker.getUsername(), worker.getPassword(), host, port,
                "pam", worker.getProtocol());
            if (null == saltModels) {
                saltModels = new ArrayList<>();
            }
            this.remove(worker.getId());
            saltModels.add(model);
        } catch (Exception e) {
            log.error("添加缓存值失败,数据：{}", worker, e);

        }
    }

}
