package com.bocloud.cop.repository;

import java.util.List;

import com.megatron.framework.core.CurrentService;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import com.bocloud.cop.entity.CommandInstance;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.BasicGenericDao;

/**
 * 命令-任务实例DAO接口实现
 * 
 * @author weiwei
 */
@Repository("commandInstanceRepository")
public class CommandInstanceRepository extends BasicGenericDao<CommandInstance, Long> {

    public CommandInstanceRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, npJdbcTemplate, service);
    }

    public List<CommandInstance> list(Long commandId) {
        String sql = "select * from command_instance where command_id = :commandId";
        return this.list(CommandInstance.class, sql, MapTools.simpleMap("commandId", commandId));
    }

    public boolean deleteByCommand(Long commandId) {
        String sql = "delete from command_instance where command_id = :commandId";
        return this.execute(sql, MapTools.simpleMap("commandId", commandId)) > 0;
    }

    public boolean deleteByInstance(Long instanceId) {
        String sql = "delete from command_instance where instance_id = :instanceId";
        return this.execute(sql, MapTools.simpleMap("instanceId", instanceId)) > 0;
    }

}
