package com.bocloud.cop.repository;

import java.util.List;

import com.megatron.framework.core.CurrentService;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import com.bocloud.cop.entity.SoftwareTenant;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.BasicGenericDao;

/**
 * @author zoucg
 * @Company: 博云 www.bocloud.com
 * @ClassName: SoftwareTenantRepository
 * @Description:
 * @DATE: 2022/9/14
 */
@Repository("softwareTenantRepository")
public class SoftwareTenantRepository extends BasicGenericDao<SoftwareTenant, Long> {
    public SoftwareTenantRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate namedParameterJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, namedParameterJdbcTemplate, service);
    }

    public boolean delete(List<Long> ids) {
        String sql = "delete from software_tenant where id in(:ids)";
        return this.execute(sql, MapTools.simpleMap("ids", ids)) > 0;
    }

    public List<SoftwareTenant> listBySoftwareId(Long softwareId) {
        String sql = "select a.* from software_tenant a where a.software_id = :softwareId";
        return this.list(SoftwareTenant.class, sql, MapTools.simpleMap("softwareId", softwareId));
    }

    public List<SoftwareTenant> listByTenantId(Long tenantId) {
        String sql = "select a.* from software_tenant a where a.tenant_id = :tenantId";
        return this.list(SoftwareTenant.class, sql, MapTools.simpleMap("tenantId", tenantId));
    }

}
