package com.bocloud.cop.repository.inspection;

import java.util.List;
import java.util.Map;

import com.megatron.framework.core.CurrentService;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import com.bocloud.cop.entity.inspection.InspectGroup;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.JdbcGenericDao;

@Repository("inspectGroupRepository")
public class InspectGroupRepository extends JdbcGenericDao<InspectGroup, Long> {

    public InspectGroupRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, npJdbcTemplate, service);
    }

    public List<InspectGroup> findAllByRoutineId(Long inspectId) {
        String sql = "select a.* from inspect_group a where a.inspect_id = :inspectId and a.is_deleted = 0";
        return this.list(InspectGroup.class, sql, MapTools.simpleMap("inspectId", inspectId));
    }

    public Integer deleteByRoutineId(Long inspectId, Long menderId) {
        String sql =
            "update inspect_group set is_deleted = 1 , mender_id = :menderId ,gmt_modify = now() where inspect_id =:inspectId";
        Map<String, Object> params = MapTools.simpleMap("inspectId", inspectId);
        params.put("menderId", menderId);
        return this.execute(sql, params);
    }
}
