package com.bocloud.cop.repository.inspection;

import java.util.List;

import com.megatron.framework.core.CurrentService;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import com.bocloud.cop.entity.inspection.InspectTemplateItem;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.BasicGenericDao;

@Repository("inspectTemplateItemRepository")
public class InspectTemplateItemRepository extends BasicGenericDao<InspectTemplateItem, Long> {

    public InspectTemplateItemRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, npJdbcTemplate, service);
    }

    public List<InspectTemplateItem> count(Long itemId) {
        String sql = "select a.* from inspect_template_item a where  a.item_id = :itemId";
        return this.list(InspectTemplateItem.class, sql, MapTools.simpleMap("itemId", itemId));
    }

    public Integer deleteByTemplateId(Long templateId) {
        String sql = "delete from inspect_template_item where template_id =:templateId ";
        return this.execute(sql, MapTools.simpleMap("templateId", templateId));
    }

}
