package com.bocloud.cop.repository.inspection;

import com.bocloud.cop.entity.inspection.InspectTemplate;
import com.megatron.common.model.Pager;
import com.megatron.common.model.Param;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.JdbcGenericDao;
import com.megatron.framework.core.CurrentService;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

@Repository("inspectTemplateRepository")
public class InspectTemplateRepository extends JdbcGenericDao<InspectTemplate, Long> {

    public InspectTemplateRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, npJdbcTemplate, service);
    }

    public int count(List<Param> params) {
        String sql = "select count(1) from inspect_template a where a.is_deleted = 0";
        sql = this.getQueryBuilder().buildRaw(sql, params, null, "a");
        return this.countQuery(sql, this.getQueryBuilder().getParam(params)).intValue();
    }

    public List<InspectTemplate> list(Pager pager) {
        String sql = "select a.*  from inspect_template a  where a.is_deleted = 0";
        sql = this.getQueryBuilder().buildRaw(sql, pager, "a");
        return this.list(InspectTemplate.class, sql);
    }

    public Integer delete(Long id, Long menderId) {
        String sql = "update inspect_template set is_deleted = 1 , mender_id = :menderId ,"
            + "gmt_modify = now() where id  =:id ";
        Map<String, Object> params = MapTools.simpleMap("id", id);
        params.put("menderId", menderId);
        return this.execute(sql, params);
    }

    public InspectTemplate findById(Long id) {
        String sql = "select a.* from inspect_template a where a.is_deleted = 0 and a.id = :id";
        return this.list(InspectTemplate.class, sql, MapTools.simpleMap("id", id)).stream().findFirst().orElse(null);
    }

    public boolean exists(String name) {
        String sql = "select a.id from inspect_template a  where a.is_deleted = 0 and a.name = :name";
        List<InspectTemplate> list = this.list(InspectTemplate.class, sql, MapTools.simpleMap("name", name));
        return !list.isEmpty();
    }

}
