package com.bocloud.cop.repository.module;

import java.util.List;
import java.util.Set;

import com.megatron.framework.core.CurrentService;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import com.bocloud.cop.entity.module.TaskNodeModuleParamItem;
import com.megatron.common.utils.MapTools;
import com.megatron.database.core.intf.impl.BasicGenericDao;

/**
 * @author zoucg
 * @Company: 博云 www.bocloud.com
 * @ClassName: TaskNodeModuleParamItemRepository
 * @Description: 自定义属性选项配置
 * @DATE: 2022/6/29
 */
@Repository("taskNodeModuleParamItemRepository")
public class TaskNodeModuleParamItemRepository extends BasicGenericDao<TaskNodeModuleParamItem, Long> {

    public TaskNodeModuleParamItemRepository(JdbcTemplate jdbcTemplate, NamedParameterJdbcTemplate npJdbcTemplate, CurrentService service) {
        super(jdbcTemplate, npJdbcTemplate, service);
    }

    public List<TaskNodeModuleParamItem> queryByParamIds(Set<Long> paramIds) {
        String sql = "select a.* from task_node_module_param_item a where a.param_id in(:paramIds)";
        return this.list(TaskNodeModuleParamItem.class, sql, MapTools.simpleMap("paramIds", paramIds));
    }

    public Boolean deleteByIds(Set<Long> ids) {
        String sql = "delete from task_node_module_param_item where id in (:ids)";
        return this.execute(sql, MapTools.simpleMap("ids", ids)) > 0;
    }

}
