package com.bocloud.cop.intf;

import java.util.List;

import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.GridBean;
import com.megatron.common.model.Pager;
import com.bocloud.cop.entity.Command;

/**
 * 命令service接口
 */
public interface CommandService {

    /**
     * 列表
     * 
     * @param pager
     * @return
     */
    public GeneralResult<GridBean<Command>> list(Pager pager);

    /**
     * 创建
     * 
     * @param command
     * @param userId
     * @return
     */
    public GeneralResult<Void> create(Command command, Long userId);

    /**
     * 修改
     * 
     * @param command
     * @param userId
     * @return
     */
    public GeneralResult<Void> modify(Command command, Long userId);

    /**
     * 删除
     * 
     * @param id
     * @return
     */
    public GeneralResult<Void> remove(Long id, Long userId);

    /**
     * 详情
     * 
     * @param id
     * @return
     */
    public GeneralResult<Command> detail(Long id);

    /**
     * 查询角色的命令
     * 
     * @param roleId
     * @return
     */
    public GeneralResult<List<Command>> listCommands(Long roleId);

    /**
     * 授权命令
     * 
     * @param roleId
     * @param commands
     * @return
     */
    public GeneralResult<Void> accCommand(Long roleId, String commands);

    public List<Long> getCommands(String content);

}
