package com.bocloud.cop.intf;

import com.bocloud.cop.entity.Identification;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.GridBean;
import com.megatron.common.model.Pager;
import com.megatron.common.model.RequestContext;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.Map;

/**
 * 认证service接口
 */
public interface IdentificationService {

    /**
     * 认证列表
     * 
     * @param pager
     * @return
     */
    public GeneralResult<GridBean<Identification>> list(Pager pager);

    public GeneralResult<GridBean<Identification>> simple(Pager pager);

    /**
     * 创建认证
     * 
     * @param identification
     * @param userId
     * @return
     */
    public GeneralResult<Void> create(Identification identification, Long userId);

    /**
     * 修改认证
     * 
     * @param identification
     * @param userId
     * @return
     */
    public GeneralResult<Void> modify(Identification identification, Long userId);

    /**
     * 删除认证
     * 
     * @param id
     * @return
     */
    public GeneralResult<Void> remove(Long id, RequestContext context);

    /**
     * 认证详情
     * 
     * @param id
     * @return
     */
    public GeneralResult<Identification> detail(Long id);

    /**
     * 导入excel
     * @param excel excel文件
     * @param context 操作人
     * @return 导入结果
     * @throws IOException io异常
     */
    GeneralResult<Void> importExcel(MultipartFile excel, RequestContext context) throws IOException;

    /**
     * 模板下载
     *
     * @param paramsMap 参数
     * @return 模板下载结果
     */
    GeneralResult<Map<String, Object>> download(Map<String, Object> paramsMap);
}
