package com.bocloud.cop.intf;

import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.GridBean;
import com.megatron.common.model.Pager;
import com.megatron.common.model.SimpleBean;
import com.bocloud.cop.entity.NodeTemplate;

public interface NodeTemplateService {

	/**
	 * 查询任务节点模板列表
	 * 
	 * @param pager
	 * @return
	 */
	public GeneralResult<GridBean<NodeTemplate>> list(Pager pager);
	public GeneralResult<GridBean<SimpleBean>> simple(Pager pager);

	/**
	 * 创建任务节点模板
	 * 
	 * @param template
	 * @return
	 */
	public GeneralResult<Void> create(NodeTemplate template);

	/**
	 * 更新任务节点模板
	 * 
	 * @param template
	 * @return
	 */
	public GeneralResult<Void> modify(NodeTemplate template);

	/**
	 * 删除任务节点模板
	 * 
	 * @param id
	 * @param userId
	 * @return
	 */
	public GeneralResult<Void> remove(Long id, Long userId);

	/**
	 * 查看任务节点模板详情
	 * 
	 * @param id
	 * @return
	 */
	public GeneralResult<NodeTemplate> detail(Long id);

}
