package com.bocloud.cop.intf;

import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.GridBean;
import com.megatron.common.model.Pager;
import com.megatron.common.model.SimpleBean;
import com.bocloud.cop.entity.Script;
import com.bocloud.cop.entity.ScriptContent;
import com.bocloud.cop.entity.ScriptVersion;
import com.bocloud.cop.model.ScriptBean;

import java.util.List;

/**
 * 脚本版本类Service
 * 
 * @author wangshuai
 * @since 2011.01.11
 */
public interface ScriptVersionService {

    /**
     * 脚本版本列表显示
     * 
     * @param pager
     * @return
     */
    public GeneralResult<GridBean<ScriptVersion>> list(Pager pager);
    public GeneralResult<GridBean<SimpleBean>> simple(Pager pager);

    /**
     * 脚本新版本创建
     * 
     * @param bean
     * @param userId
     * @return
     */
    public GeneralResult<Void> create(ScriptBean bean, Long userId);

    /**
     * 脚本版本修改
     * 
     * @param bean
     * @param userId
     * @return
     */
    public GeneralResult<Void> modify(ScriptBean bean, Long userId);

    /**
     * 脚本版本详细
     * 
     * @param id
     * @return
     */
    public GeneralResult<Script> detail(Long id);

    /**
     * 脚本版本删除
     * 
     * @param id
     * @param userId
     * @return
     */
    public GeneralResult<Void> remove(Long id, Long userId);

    /**
     * 脚本版本对比
     * 
     * @param id
     * @return
     */
    public GeneralResult<List<ScriptContent>> compare(Long id);

}
