package com.bocloud.cop.intf;

import java.util.List;

import com.bocloud.cop.entity.TaskNode;
import com.bocloud.cop.entity.TaskNodeLog;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.RequestContext;
import com.megatron.common.model.Result;

/**
 * 任务记录Service接口
 * 
 * @author wei wei
 * @version 1.0
 * @since 2016.08.17
 */
public interface TaskNodeService {

    public GeneralResult<Void> modify(TaskNode node);

    /**
     * 查询作业记录详细
     * 
     * @param id
     * @return
     */
    public GeneralResult<TaskNode> detail(Long id);

    /**
     * 通过ID得到任务节点
     * 
     * @param id
     * @return
     */
    public TaskNode get(Long id);

    /**
     * 得到实例任务节点
     * 
     * @param instanceId
     * @return
     */
    public List<TaskNode> getNodes(Long instanceId);

    /**
     * 修改节点状态
     * 
     * @param id
     * @param status
     * @param userId
     * @return
     */
    public Result updateStatus(Long id, String status, Long userId);

    public GeneralResult<?> create(TaskNodeLog log);

    public GeneralResult<?> getLog(Long nodeId, Integer priority, Boolean end);

    public GeneralResult<TaskNode> skip(Long id, RequestContext context);

}
