package com.bocloud.cop.intf;

import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.GridBean;
import com.megatron.common.model.Pager;
import com.megatron.common.model.RequestContext;
import com.bocloud.cop.entity.TaskPlatformAlert;

/**
 * 任务实例平台告警接口
 *
 * @author majiali
 * @version 1.0
 * @since 2022.08.24
 */
public interface TaskPlatformAlertService {

    /**
     * 查询任务平台告警列表
     *
     * @param pager
     * @param context
     * @return
     */
    public GeneralResult<GridBean<TaskPlatformAlert>> list(Pager pager, RequestContext context);

    /**
     * 更新任务平台告警记录
     *
     * @param instance
     * @return
     */
    public GeneralResult<Void> modify(TaskPlatformAlert instance, Long userId);

    public GeneralResult<Void> remove(Long id, Long userId);

    public GeneralResult<?> instanceList(Long id, String type, Pager pager);
}
