package com.bocloud.cop.intf;


import com.bocloud.cop.entity.TaskPlatformConfig;
import com.bocloud.cop.model.TaskPlatformModel;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.GridBean;
import com.megatron.common.model.Pager;
import com.megatron.common.model.RequestContext;

/**
 * 任务实例平台接口
 *
 * @author majiali
 * @version 1.0
 * @since 2022.08.24
 */
public interface TaskPlatformConfigService {

    /**
     * 查询任务平台列表
     *
     * @param pager
     * @param context
     * @return
     */
    public GeneralResult<GridBean<TaskPlatformConfig>> list(Pager pager, RequestContext context);

    /**
     * 查询任务平台详细
     *
     * @param id
     * @return
     */
    public GeneralResult<TaskPlatformConfig> get(Long id);

    /**
     * 添加任务平台记录
     *
     * @param instance
     * @return
     */
    public GeneralResult<Void> create(TaskPlatformConfig instance, Long userId);

    /**
     * 更新任务平台记录
     *
     * @param instance
     * @return
     */
    public GeneralResult<Void> modify(TaskPlatformConfig instance, Long userId);

    public GeneralResult<Void> remove(Long id, Long userId);

    public GeneralResult<Void> updateOpened(Long id, Boolean limited, Long userId);

    public GeneralResult<TaskPlatformModel> chargeLimit(String platform, int targetHostNum);

    public boolean limitSwitch();

    public GeneralResult<Void> updatePlatformRedis(Long id);
    public GeneralResult<TaskPlatformConfig> exists(String name);


}
