package com.bocloud.cop.intf;

import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.GridBean;
import com.megatron.common.model.Pager;
import com.megatron.common.model.RequestContext;
import com.bocloud.cop.entity.TaskPlatform;

/**
 * 任务实例平台接口
 *
 * @author majiali
 * @version 1.0
 * @since 2022.08.24
 */
public interface TaskPlatformService {

    /**
     * 查询任务平台列表
     *
     * @return
     */
    public GeneralResult<GridBean<TaskPlatform>> list(Pager pager, RequestContext context);

    public GeneralResult<?> listAll();

    public GeneralResult<Void> create(TaskPlatform platform, Long userId);

    /**
     * 更新任务平台记录
     *
     * @param platform
     * @return
     */
    public GeneralResult<Void> modify(TaskPlatform platform, Long userId);

    public GeneralResult<Void> remove(Long id, Long userId);



}
