package com.bocloud.cop.intf;

import java.util.List;

import com.bocloud.cop.entity.TaskTemplate;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.GridBean;
import com.megatron.common.model.Pager;
import com.megatron.common.model.RequestContext;
import com.megatron.common.model.SimpleBean;

public interface TaskTemplateService {

    /**
     * 查询任务模板列表
     *
     * @param pager
     * @return
     */
    public GeneralResult<GridBean<TaskTemplate>> list(Pager pager, RequestContext context);

    /**
     * （自服务）查询公共模板
     * 
     * @param pager
     * @param context
     * @return
     */
    public GeneralResult<GridBean<TaskTemplate>> listAllot(Pager pager, RequestContext context);

    public GeneralResult<GridBean<SimpleBean>> simple(Pager pager);

    /**
     * 创建任务模板
     *
     * @param template
     * @return
     */
    public GeneralResult<TaskTemplate> create(TaskTemplate template, RequestContext context);

    /**
     * 更新任务模板
     *
     * @param template
     * @param context
     * @return
     */
    public GeneralResult<TaskTemplate> modify(TaskTemplate template, RequestContext context);

    /**
     * 删除任务模板
     *
     * @param id
     * @param userId
     * @return
     */
    public GeneralResult<Void> remove(Long id, Long userId);

    /**
     * 查看任务模板详情
     *
     * @param id
     * @return
     */
    public GeneralResult<TaskTemplate> detail(Long id);

    /**
     * 克隆任务模板
     *
     * @param id
     * @return
     */
    public GeneralResult<TaskTemplate> clone(Long id);

    /**
     * 任务模板基本信息
     *
     * @param id
     * @return
     */
    public TaskTemplate basic(Long id);

    /**
     * 更新任务模板状态
     *
     * @param id
     * @param status
     * @param userId
     * @return
     */
    public GeneralResult<Void> updateStatus(Long id, String status, Long userId);

    /**
     * 分配模板
     *
     * @param tenantId
     * @param templateIds
     * @return
     */
    public GeneralResult<Void> allot(Long tenantId, List<Long> templateIds);

    /**
     * 分配租户列表
     *
     * @param tenantId
     * @return
     */
    public GeneralResult<List<TaskTemplate>> listAllotTemplates(Long tenantId);

}
