package com.bocloud.cop.intf.inspection;

import com.bocloud.cop.entity.inspection.RecordItem;

/**
 * 可借鉴
 */
public interface DataAdaptorService {

    /**
     * 将 日志内容解析至 巡检记录条目中（包含数据库数据写入）
     * <p>
     * 1.数据解析，将content解析 2.数据分析 分析解析出的数据 生成分析结果（比如巡检结果） 3.数据录入 将以上过程中需要的数据写入数据库
     *
     * @param content
     *            与巡检记录条目相关的日志
     * @param item
     *            巡检记录条目
     */
    void handleContent(RecordItem item, String content);

    /**
     * 同步当前记录的数据
     *
     * @param recordId
     */
    void synRecord(Long recordId);
}
