package com.bocloud.cop.intf.inspection;

import com.bocloud.cop.entity.inspection.InspectRecordWarning;
import com.bocloud.cop.entity.inspection.InspectReportDetail;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.GridBean;
import com.megatron.common.model.Pager;
import jakarta.servlet.http.HttpServletResponse;

import java.util.List;

/**
 * 巡检报表详情Service
 */
public interface InspectReportDetailService {

    /**
     * 翻页查询所有
     *
     * @param pager
     */
    GeneralResult<GridBean<InspectReportDetail>> list(Pager pager);

    /**
     * 添加
     *
     * @param reportId
     * @param userId
     */
    GeneralResult<InspectReportDetail> create(Long reportId, Long userId);

    /**
     * 详情
     *
     * @param id
     */
    GeneralResult<InspectReportDetail> detail(Long id);

    /**
     * 详情
     * 
     * @param id
     * @param params
     * @return
     */
    GeneralResult<List<InspectRecordWarning>> detail(Long id, Long key);

    /**
     * pdf导出
     * 
     * @param id
     * @param response
     */
    void pdf(Long id, HttpServletResponse response);

    /**
     * excel导出
     * 
     * @param id
     * @param response
     */
    void excel(Long id, HttpServletResponse response);
}
