package com.bocloud.cop.intf.inspection;

import com.bocloud.cop.entity.inspection.InspectReport;
import com.bocloud.cop.model.OperationParam;
import com.megatron.common.model.GeneralResult;
import com.megatron.common.model.GridBean;
import com.megatron.common.model.Pager;
import com.megatron.common.model.RequestContext;

/**
 * 巡检报表Service
 */
public interface InspectReportService {

    /**
     * 查询
     *
     * @param pager
     */
    GeneralResult<GridBean<InspectReport>> list(Pager pager);

    /**
     * 添加
     *
     * @param report
     * @param userId
     */
    GeneralResult<Void> create(InspectReport report, Long userId);

    /**
     * 修改
     *
     * @param id
     * @param entity
     * @param userId
     */
    GeneralResult<Void> modify(Long id, InspectReport report, Long userId);

    /**
     * 删除
     *
     * @param id
     * @param userId
     */
    GeneralResult<InspectReport> remove(Long id, Long userId);

    /**
     * 详情
     *
     * @param id
     */
    GeneralResult<InspectReport> detail(Long id);

    GeneralResult<String> addScheduleIfLeader(Long id);

    GeneralResult<String> removeScheduleIfLeader(Long id);

    void onApplicationReadyEvent();

    GeneralResult<Void> start(Long id, String action, OperationParam param, RequestContext user);

}
