package com.bocloud.cop.service.utils;

import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.alibaba.fastjson.JSONObject;
import com.bocloud.cmp.boot.model.BoCloudService;
import com.bocloud.cmp.boot.model.BocloudToken;
import com.bocloud.cop.intf.TaskInstanceService;
import com.bocloud.cop.model.Job;
import com.megatron.common.enums.PostDataFormat;
import com.megatron.framework.core.CurrentService;
import com.megatron.framework.core.Service;
import com.megatron.framework.http.core.HttpMethod;
import com.megatron.framework.http.core.ServiceFactory;
import com.megatron.framework.http.model.RemoteService;

@Component
public class JobScheduler implements InitializingBean {

    private static final Service SERVICE = Service.create(BoCloudService.TSE.getName());
    private Map<String, Object> headers = new HashMap<>(4);

    @Autowired
    private ServiceFactory serviceFactory;
    @Autowired
    private CurrentService currentService;
    @Autowired
    private TaskInstanceService taskInstanceService;

    public boolean insertTask(Job job) {
        return taskInstanceService.putJob(job).isSuccess();
    }

    public boolean removeCronTask(String uuid) {
        String url = "/v1/task/scheduler";
        JSONObject object = new JSONObject();
        object.put("type", "remove");
        object.put("data", uuid);
        RemoteService remoteService = serviceFactory.build(SERVICE, url, HttpMethod.POST, headers, object);
        remoteService.setDataFormat(PostDataFormat.RAW);
        return remoteService.invoke().isSuccess();
    }

    @Override
    public void afterPropertiesSet() throws Exception {
        this.headers.put(BocloudToken.INTERNAL_TOKEN, currentService.getToken());
        this.headers.put("source", currentService.getService().getName());
    }
}
