package com.bocloud.cop.service.utils;

import com.megatron.common.enums.OSCategory;

/**
 * ssh管理端口工具类
 *
 * @author sxp
 * @since Dec 27, 2017
 */
public class SshPortHelper {

    private SshPortHelper() {
        throw new IllegalStateException("Utility class");
    }

    /**
     * 根据操作系统类别获取默认的SSH管理端口
     *
     * @author sxp
     * @since Dec 27, 2017
     */
    public static int getDefaultPort(OSCategory category) {
        int port;

        switch (category) {
            case WINDOWS:
                port = 5986;
                break;
            case LINUX:
                port = 22;
                break;
            case UNIX:
                port = 22;
                break;
            default:
                port = 22;
                break;
        }

        return port;
    }

    /**
     * 根据操作系统类别获取默认的SSH管理端口
     *
     * @author sxp
     * @since Dec 27, 2017
     */
    public static int getDefaultPort(String osCategoryName) {
        OSCategory category = OsCategoryUtils.getOSCategory(osCategoryName);
        return getDefaultPort(category);
    }

}
