package com.bocloud.cop.service.utils;

import java.io.File;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

/**
 * nfs路径配置
 * 
 * @author 007
 *
 */
@Component
public class StorageConfig {

    @Value("${spring.upload.path:/home/cmp}")
    private String path;

    /**
     * @return the path
     */
    public String getPath() {
        if (this.path.endsWith(File.separatorChar + "")) {
            return this.path.substring(0, this.path.length() - 1);
        }
        return path;
    }

    /**
     * @param path
     *            the path to set
     */
    public void setPath(String path) {
        this.path = path;
    }

    /**
     * 获取巡检路径
     * @return 路径
     */
    public String getInspectionPath(){
        return getPath() + "/inspection";
    }

}